"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _PublicKey = _interopRequireDefault(require("../../ecc/src/PublicKey"));

var FastParser = /*#__PURE__*/function () {
  function FastParser() {
    (0, _classCallCheck2["default"])(this, FastParser);
  }

  (0, _createClass2["default"])(FastParser, null, [{
    key: "fixed_data",
    value: function fixed_data(b, len, buffer) {
      if (!b) {
        return;
      }

      if (buffer) {
        var data = buffer.slice(0, len).toString('binary');
        b.append(data, 'binary');

        while (len-- > data.length) {
          b.writeUint8(0);
        }
      } else {
        var b_copy = b.copy(b.offset, b.offset + len);
        b.skip(len);
        return new Buffer(b_copy.toBinary(), 'binary');
      }
    }
  }, {
    key: "public_key",
    value: function public_key(b, _public_key) {
      if (!b) {
        return;
      }

      if (_public_key) {
        var buffer = _public_key.toBuffer();

        b.append(buffer.toString('binary'), 'binary');
        return;
      } else {
        buffer = FastParser.fixed_data(b, 33);
        return _PublicKey["default"].fromBuffer(buffer);
      }
    }
  }, {
    key: "ripemd160",
    value: function ripemd160(b, _ripemd) {
      if (!b) {
        return;
      }

      if (_ripemd) {
        FastParser.fixed_data(b, 20, _ripemd);
        return;
      } else {
        return FastParser.fixed_data(b, 20);
      }
    }
  }, {
    key: "time_point_sec",
    value: function time_point_sec(b, epoch) {
      if (epoch) {
        epoch = Math.ceil(epoch / 1000);
        b.writeInt32(epoch);
        return;
      } else {
        epoch = b.readInt32(); // fc::time_point_sec

        return new Date(epoch * 1000);
      }
    }
  }]);
  return FastParser;
}();

var _default = FastParser;
exports["default"] = _default;